package de.uka.algo.GT3D;



/**
 * @author stm
 *
 * An Algorithm that can be run stepwise. 
 */
public interface StepwiseAlgorithm {

	
	/**
	 * Do the necessary initialization before the first step.
	 * 
	 * @param filename The name of a Graph(ML) file.
	 */
	public void init(String filename);
	
	/**
	 * Perform the next step of the algorithm.
	 */
	public void nextStep();
	
	/**
	 * Undo the last step of the algorithm (optional)
	 */
	public void previousStep();
	
	
	/**
	 * 
	 * @return <code>true</code> iff the algorithm has terminated.
	 */
	public boolean finished();
	
	/**
	 * 
	 * @return <code>true</code> iff the algorithm is in its starting state.
	 */
	public boolean atStart();
	
	
}
